<?php
 
 namespace App\Http\Controllers;
 
 use App\Http\Controllers\Controller;
use App\Models\CatModel;
 use Illuminate\Http\Request;
  

class Catalogos extends Controller
{
   public function catPrincipal(){

    $catPrincipal = CatModel :: getTablaConFlujos();

    return response()->json($catPrincipal);
   }

   public function proveedores(){

    $catPrincipal = CatModel :: getProveedores();

    return response()->json($catPrincipal);
   }

   public function cat1(){

    $catNivel1 = CatModel :: cat1();

    return response()->json($catNivel1);
   }

   public function insertCats(Request $request){

      $data = $request->all(); 

      $insertCat = CatModel :: insertCatalogo($data);
   
      if($insertCat) {
         // Retorna una respuesta JSON de éxito
         return response()->json([
             'success' => true,
             'message' => 'Datos insertados correctamente.',
             'data' => $insertCat // Opcional: puedes retornar el ID insertado u otros datos
         ], 200); // Código de estado HTTP 200 para éxito
     } else {
         // Retorna una respuesta JSON de error si la inserción falla
         return response()->json([
             'success' => false,
             'message' => 'No se pudo insertar los datos.'
         ], 500); // Código de estado HTTP 500 para error del servidor
     }
     }

     public function insertProveedor(Request $request){

        // Controlador
        $datos = $request->input('rows');

        $insertData = [];
        foreach ($datos as $item) {
            // Aseguramos que cada $item sea un array y tenga la clave `PROVEEDOR`
            if (is_array($item) && isset($item['PROVEEDOR'])) {
                $insertData[] = ['PROVEEDOR' => $item['PROVEEDOR']];  // Preparamos los datos para la inserción
            }
        }

        // Verificamos si tenemos datos para insertar
        if (!empty($insertData)) {
            $insertCat = CatModel::insertProveedores($insertData);

            if ($insertCat) {
                // Inserción exitosa
                return response()->json(['success' => true]);
            } else {
                // Manejo de error
                return response()->json(['success' => false, 'message' => 'Error al insertar']);
            }
        } else {
            // Manejo de caso en el que no hay datos válidos para insertar
            return response()->json(['success' => false, 'message' => 'No hay datos válidos para insertar']);
        }
       }

       public function insertNivel1(Request $request){

        // Controlador
        $datos = $request->input('rows');

        $insertData = [];
        foreach ($datos as $item) {
            // Aseguramos que cada $item sea un array y tenga la clave `PROVEEDOR`
            if (is_array($item) && isset($item['COD_N1']) && isset($item['NIVEL_1'])) {
                $insertData[] = [
                    'COD_N1' => $item['COD_N1'],
                    'NIVEL_1' => $item['NIVEL_1']
                ];  // Preparamos los datos para la inserción
            }
        }

        // Verificamos si tenemos datos para insertar
        if (!empty($insertData)) {
            $insertCat = CatModel::insertNivel1($insertData);

            if ($insertCat) {
                // Inserción exitosa
                return response()->json(['success' => true]);
            } else {
                // Manejo de error
                return response()->json(['success' => false, 'message' => 'Error al insertar']);
            }
        } else {
            // Manejo de caso en el que no hay datos válidos para insertar
            return response()->json(['success' => false, 'message' => 'No hay datos válidos para insertar']);
        }
       }
     
       public function cat2(){

        $catNivel2 = CatModel :: cat2();
    
        return response()->json($catNivel2);
       }

       public function insertNivel2(Request $request){

        // Controlador
        $datos = $request->input('rows');

        $insertData = [];
        foreach ($datos as $item) {
            // Aseguramos que cada $item sea un array y tenga la clave `PROVEEDOR`
            if (is_array($item) && isset($item['COD_N2']) && isset($item['NIVEL_2'])) {
                $insertData[] = [
                    'COD_N2' => $item['COD_N2'],
                    'NIVEL_2' => $item['NIVEL_2']
                ];  // Preparamos los datos para la inserción
            }
        }

        // Verificamos si tenemos datos para insertar
        if (!empty($insertData)) {
            $insertCat = CatModel::insertNivel2($insertData);

            if ($insertCat) {
                // Inserción exitosa
                return response()->json(['success' => true]);
            } else {
                // Manejo de error
                return response()->json(['success' => false, 'message' => 'Error al insertar']);
            }
        } else {
            // Manejo de caso en el que no hay datos válidos para insertar
            return response()->json(['success' => false, 'message' => 'No hay datos válidos para insertar']);
        }
       }

       //cat3
       public function cat3(){

        $catNivel3 = CatModel :: cat3();
    
        return response()->json($catNivel3);
       }

       public function insertNivel3(Request $request){

        // Controlador
        $datos = $request->input('rows');

        $insertData = [];
        foreach ($datos as $item) {
            // Aseguramos que cada $item sea un array y tenga la clave `PROVEEDOR`
            if (is_array($item) && isset($item['COD_N3']) && isset($item['NIVEL_3'])) {
                $insertData[] = [
                    'COD_N3' => $item['COD_N3'],
                    'NIVEL_3' => $item['NIVEL_3']
                ];  // Preparamos los datos para la inserción
            }
        }

        // Verificamos si tenemos datos para insertar
        if (!empty($insertData)) {
            $insertCat = CatModel::insertNivel3($insertData);

            if ($insertCat) {
                // Inserción exitosa
                return response()->json(['success' => true]);
            } else {
                // Manejo de error
                return response()->json(['success' => false, 'message' => 'Error al insertar']);
            }
        } else {
            // Manejo de caso en el que no hay datos válidos para insertar
            return response()->json(['success' => false, 'message' => 'No hay datos válidos para insertar']);
        }
       }

       //CAT 4
       public function cat4(){

        $catNivel4 = CatModel :: cat4();
    
        return response()->json($catNivel4);
       }

       public function insertNivel4(Request $request){

        // Controlador
        $datos = $request->input('rows');

        $insertData = [];
        foreach ($datos as $item) {
            // Aseguramos que cada $item sea un array y tenga la clave `PROVEEDOR`
            if (is_array($item) && isset($item['COD_N4']) && isset($item['NIVEL_4'])) {
                $insertData[] = [
                    'COD_N4' => $item['COD_N4'],
                    'NIVEL_4' => $item['NIVEL_4']
                ];  // Preparamos los datos para la inserción
            }
        }

        // Verificamos si tenemos datos para insertar
        if (!empty($insertData)) {
            $insertCat = CatModel::insertNivel4($insertData);

            if ($insertCat) {
                // Inserción exitosa
                return response()->json(['success' => true]);
            } else {
                // Manejo de error
                return response()->json(['success' => false, 'message' => 'Error al insertar']);
            }
        } else {
            // Manejo de caso en el que no hay datos válidos para insertar
            return response()->json(['success' => false, 'message' => 'No hay datos válidos para insertar']);
        }
       }

       //Cat 5
       public function cat5(){

        $catNivel5 = CatModel :: cat5();
    
        return response()->json($catNivel5);
       }

       public function insertNivel5(Request $request){

        // Controlador
        $datos = $request->input('rows');

        $insertData = [];
        foreach ($datos as $item) {
            // Aseguramos que cada $item sea un array y tenga la clave `PROVEEDOR`
            if (is_array($item) && isset($item['COD_N5']) && isset($item['NIVEL_5'])) {
                $insertData[] = [
                    'COD_N5' => $item['COD_N5'],
                    'NIVEL_5' => $item['NIVEL_5']
                ];  // Preparamos los datos para la inserción
            }
        }

        // Verificamos si tenemos datos para insertar
        if (!empty($insertData)) {
            $insertCat = CatModel::insertNivel5($insertData);

            if ($insertCat) {
                // Inserción exitosa
                return response()->json(['success' => true]);
            } else {
                // Manejo de error
                return response()->json(['success' => false, 'message' => 'Error al insertar']);
            }
        } else {
            // Manejo de caso en el que no hay datos válidos para insertar
            return response()->json(['success' => false, 'message' => 'No hay datos válidos para insertar']);
        }
       }

       //Cat 6
       public function cat6(){

        $catNivel6 = CatModel :: cat6();
    
        return response()->json($catNivel6);
       }

       public function insertNivel6(Request $request){

        // Controlador
        $datos = $request->input('rows');

        $insertData = [];
        foreach ($datos as $item) {
            // Aseguramos que cada $item sea un array y tenga la clave `PROVEEDOR`
            if (is_array($item) && isset($item['COD_N6']) && isset($item['NIVEL_6'])) {
                $insertData[] = [
                    'COD_N6' => $item['COD_N6'],
                    'NIVEL_6' => $item['NIVEL_6']
                ];  // Preparamos los datos para la inserción
            }
        }

        // Verificamos si tenemos datos para insertar
        if (!empty($insertData)) {
            $insertCat = CatModel::insertNivel6($insertData);

            if ($insertCat) {
                // Inserción exitosa
                return response()->json(['success' => true]);
            } else {
                // Manejo de error
                return response()->json(['success' => false, 'message' => 'Error al insertar']);
            }
        } else {
            // Manejo de caso en el que no hay datos válidos para insertar
            return response()->json(['success' => false, 'message' => 'No hay datos válidos para insertar']);
        }
       }

       //Cat 7 
       public function cat7(){

        $catNivel7 = CatModel :: cat7();
    
        return response()->json($catNivel7);
       }

       public function insertNivel7(Request $request){

        // Controlador
        $datos = $request->input('rows');

        $insertData = [];
        foreach ($datos as $item) {
            // Aseguramos que cada $item sea un array y tenga la clave `PROVEEDOR`
            if (is_array($item) && isset($item['COD_N7']) && isset($item['NIVEL_7'])) {
                $insertData[] = [
                    'COD_N7' => $item['COD_N7'],
                    'NIVEL_7' => $item['NIVEL_7']
                ];  // Preparamos los datos para la inserción
            }
        }

        // Verificamos si tenemos datos para insertar
        if (!empty($insertData)) {
            $insertCat = CatModel::insertNivel7($insertData);

            if ($insertCat) {
                // Inserción exitosa
                return response()->json(['success' => true]);
            } else {
                // Manejo de error
                return response()->json(['success' => false, 'message' => 'Error al insertar']);
            }
        } else {
            // Manejo de caso en el que no hay datos válidos para insertar
            return response()->json(['success' => false, 'message' => 'No hay datos válidos para insertar']);
        }
       }

       public function updateCat1(Request $request){
        $data = $request->input('catGeneral');

        $catUpdate = CatModel :: updateTab1($data);

        if($catUpdate){
            return response() -> json(['message' => 'Datos Actualizados Correctamente'],200);
        }else{
            return response() -> json(['message' => 'No se ha podido actualizar correctamente'],500);
        }
       }

       public function updateProveedoresTab(Request $request)
       {
           
           $idProveedor = $request->input('ID_PROVEEDOR');
           $proveedorName = $request->input('PROVEEDOR');
   
           $updateProv = CatModel ::updateProv($idProveedor, $proveedorName);

           if(!empty($updateProv)){

                return response() -> json (['message' => 'Se han actualizado los datos correctamente', 200]);
           }else{

                return response() -> json(['message' => 'No se han podido actualizar los datos correctamente'], 500);
           }
       }

       public function updateCn1(Request $request)
       {
            $ID_N1 = $request->input('ID_N1');
            $COD_N1 = $request->input('COD_N1');
            $NIVEL_1 = $request->input('NIVEL_1');

            $udpateLevel = CatModel ::updateCn1($ID_N1, $COD_N1,$NIVEL_1);

            if(!empty($udpateLevel)){

                return response() -> json (['message' => 'Se han actualizado los datos correctamente', 200]);
           }else{

                return response() -> json(['message' => 'No se han podido actualizar los datos correctamente'], 500);
           }

       }
       
       public function updateCn2(Request $request)
       {
            $ID_N2 = $request->input('ID_N2');
            $COD_N2 = $request->input('COD_N2');
            $NIVEL_2 = $request->input('NIVEL_2');

            $udpateLevel = CatModel ::updateCn2($ID_N2, $COD_N2,$NIVEL_2);

            if(!empty($udpateLevel)){

                return response() -> json (['message' => 'Se han actualizado los datos correctamente', 200]);
           }else{

                return response() -> json(['message' => 'No se han podido actualizar los datos correctamente'], 500);
           }

       }

       public function updateCn3(Request $request)
       {
            $ID_N3 = $request->input('ID_N3');
            $COD_N3 = $request->input('COD_N3');
            $NIVEL_3 = $request->input('NIVEL_3');

            $udpateLevel = CatModel ::updateCn3($ID_N3, $COD_N3,$NIVEL_3);

            if(!empty($udpateLevel)){

                return response() -> json (['message' => 'Se han actualizado los datos correctamente', 200]);
           }else{

                return response() -> json(['message' => 'No se han podido actualizar los datos correctamente'], 500);
           }

       }

       public function updateCn4(Request $request)
       {
            $ID_N4 = $request->input('ID_N4');
            $COD_N4 = $request->input('COD_N4');
            $NIVEL_4 = $request->input('NIVEL_4');

            $udpateLevel = CatModel ::updateCn4($ID_N4, $COD_N4,$NIVEL_4);

            if(!empty($udpateLevel)){

                return response() -> json (['message' => 'Se han actualizado los datos correctamente', 200]);
           }else{

                return response() -> json(['message' => 'No se han podido actualizar los datos correctamente'], 500);
           }

       }

       public function updateCn5(Request $request)
       {
            $ID_N5 = $request->input('ID_N5');
            $COD_N5 = $request->input('COD_N5');
            $NIVEL_5 = $request->input('NIVEL_5');

            $udpateLevel = CatModel ::updateCn5($ID_N5, $COD_N5,$NIVEL_5);

            if(!empty($udpateLevel)){

                return response() -> json (['message' => 'Se han actualizado los datos correctamente', 200]);
           }else{

                return response() -> json(['message' => 'No se han podido actualizar los datos correctamente'], 500);
           }

       }

       public function updateCn6(Request $request)
       {
            $ID_N6 = $request->input('ID_N6');
            $COD_N6 = $request->input('COD_N6');
            $NIVEL_6 = $request->input('NIVEL_6');

            $udpateLevel = CatModel ::updateCn6($ID_N6, $COD_N6,$NIVEL_6);

            if(!empty($udpateLevel)){

                return response() -> json (['message' => 'Se han actualizado los datos correctamente', 200]);
           }else{

                return response() -> json(['message' => 'No se han podido actualizar los datos correctamente'], 500);
           }

       }

       public function updateCn7(Request $request)
       {
            $ID_N7 = $request->input('ID_N7');
            $COD_N7 = $request->input('COD_N7');
            $NIVEL_7 = $request->input('NIVEL_7');

            $udpateLevel = CatModel ::updateCn7($ID_N7, $COD_N7,$NIVEL_7);

            if(!empty($udpateLevel)){

                return response() -> json (['message' => 'Se han actualizado los datos correctamente', 200]);
           }else{

                return response() -> json(['message' => 'No se han podido actualizar los datos correctamente'], 500);
           }

       }
}
