<?php
 
namespace App\Http\Controllers;
 
use App\Http\Controllers\Controller;
use App\Models\{RegistroentradasSalidas, ProrrateoGastos,ConciliacionFlujos,CatModel};
use Illuminate\Http\Request;
 
class FinanzasDat extends Controller
{
    /**
     * Show a list of all of the application's users .
     */
    public function tableEntradasSalidas()
    {
        // Usa el método personalizado del modelo para recuperar los datos
        $tablaG = RegistroentradasSalidas::getTablaEntradasSalidas();

    
          // Retorna los datos en formato JSON
          return response()->json($tablaG);
    }


    public function select2($catalogo)
    {
        switch ($catalogo) {
            case 'poliza':
                $selectData = RegistroentradasSalidas::cat_poliza();
                break;
            case 'cuenta':
                $selectData = RegistroentradasSalidas::cat_completo();
                break;
            case 'proveedor':
                $selectData = RegistroentradasSalidas::cat_proveedores();
                break;
            case 'bucket':
                $selectData = ProrrateoGastos::cat_bucket();
                break;
            case 'flu_efe':
                $selectData = ConciliacionFlujos::cat_fluEfe();
                break;
            case 'nivel1':
                $selectData = CatModel::selectN1();
                break;
            case 'nivel2':
                $selectData = CatModel::selectN2();
                break;
            case 'nivel3':
                $selectData = CatModel::selectN3();
                break;
            case 'nivel4':
                $selectData = CatModel::selectN4();
                break;
            case 'nivel5':
                $selectData = CatModel::selectN5();
                break;
            case 'nivel6':
                $selectData = CatModel::selectN6();
                break;
            case 'nivel7':
                $selectData = CatModel::selectN7();
                break;
            case 'tcuenta':
                $selectData = CatModel::tcuenta();
                break;
            case 'naturaleza':
                $selectData = CatModel::naturaleza();
                break;
            case 'catSat':
                $selectData = CatModel::catSat();
                break;
            case 'reportes':
                $selectData = CatModel::cReports();
                break;
            default:
                echo "Data no encontrada";
                break;
        }
    
          // Retorna los datos en formato JSON
          //Hola
          return response()->json($selectData);
    }

    public function addEntradasSalidas(Request $request){
        // Obtener el array de datos enviados por POST
        $datos = $request->input('rows');

        // Inicializar un array para almacenar los resultados de la inserción
        $resultados = [];
        $todoCorrecto = true; // Variable para verificar si todas las inserciones fueron exitosas

        // Iterar sobre cada fila en el array de datos
        foreach ($datos as $fila) {
            // Verificar si alguno de los campos es null o vacío
            if (!$fila['fecha'] || !$fila['selectPoliza'] || !$fila['selectCuenta'] || !$fila['selectProveedor'] || !$fila['descripcion'] || $fila['cargo'] === '' || $fila['abono'] === '') {
                // Agregar mensaje de error al resultado
                $resultados[] = ['success' => false, 'message' => 'Todos los campos son obligatorios.', 'data' => $fila];
                $todoCorrecto = false; // Marcar que hubo un error
                continue;
            }

            // Intentar insertar los datos en la base de datos
            if (/*$recordRow = */ RegistroentradasSalidas::addEntradasSalidas($fila)) {
                $resultados[] = ['success' => true, 'message' => 'Datos insertados correctamente.', 'data' => $fila];
                

                // verificar que exista y que empiecen con lo que dijo Vero
                // $patron = '/^(4\.[123]|5|6|7)(?:\.\d+)*(?:\s.*)?$/';

                // $textCuenta = trim($fila['textCuenta']); // Elimina posibles espacios en blanco al inicio y al final

                 // TODO: AJUSTAR LOS PRORRATEOS PROQUE YA NO SE INSERTARA BORRAR LA LOGICA INSERVIBLE
                // if (preg_match($patron,  $textCuenta)) {
                 
                    //Cumple los ids para prorrateo
                    // RegistroentradasSalidas::proratteoInsert($recordRow);
                   
                // } else {
                    // En caso de que no cumpla con los ID'S iniciales
                    // RegistroentradasSalidas::conciliacionflujoInsert($recordRow);
                // }
                
            } else {
                $resultados[] = ['success' => false, 'message' => 'Error al insertar los datos.', 'data' => $fila];
                $todoCorrecto = false; // Marcar que hubo un error
            }
            //CORTE DEL PRORRATEO
        }

        // Devolver la respuesta en formato JSON
        if ($todoCorrecto) {
            return response()->json(['success' => true, 'message' => 'Todos los datos se insertaron correctamente.']);
        } else {
            return response()->json(['error' => false, 'message' => 'Algunos datos no se pudieron insertar.', 'resultados' => $resultados]);
        }
    }

    public function updateEntradasSalidas(Request $request)
    {
        // Obtén los datos del request
        $rows = $request->input('data'); // Asegúrate de que los datos se envíen correctamente desde el cliente

        // Verifica que los datos no estén vacíos
        if (is_array($rows)) {
        // verificar que exista y que empiecen con lo que dijo Vero
            // foreach($rows as $row){
               
                // $patron = '/^(4\.[123]|5|6|7)(?:\.\d+)*(?:\s.*)?$/';

                // $textCuenta = trim($row['textCuenta']); // Elimina posibles espacios en blanco al inicio y al final
             
                //En caso de que sea 4.1,4.2,4.3,5,6,7
               
                // if (preg_match($patron,  $textCuenta)) {         
                 //Cumple los ids para prorrateo
                //  $updateDatapro = RegistroentradasSalidas::proratteoUpdate($row['ID_REGISTRO']);
                //  if($updateDatapro){
                //     RegistroentradasSalidas::proratteoInsert($row['ID_REGISTRO']);
                //  }
                 
                
                // } else {
                 // En caso de que no cumpla con los ID'S iniciales
                //  $updateData= RegistroentradasSalidas::conciliacionflujoUpdate($row['ID_REGISTRO']);
                //  if($updateData){
                //     RegistroentradasSalidas::conciliacionflujoInsert($row['ID_REGISTRO']);
                //  }
                 
                // }
                    //CORTE DE PRORRATEO
            // }
             
            // Llama al método del modelo para actualizar los registros
            $success = RegistroentradasSalidas::updateRowsEntradasSalidas($rows);

            // Devuelve una respuesta exitosa o de error
            if ($success) {
                return response()->json(['success' => true]);
            } else {
                return response()->json(['success' => false, 'message' => 'No se pudieron actualizar todas las filas.']);
            }
        } else {
            // Devuelve una respuesta de error si los datos están vacíos o mal formateados
            return response()->json(['success' => false, 'message' => 'Datos no válidos.']);
        }
    }
    public function delEntradasSalidas(Request $request)
    {
        // Obtén los datos del request
        $id = $request->input('idFila'); // Asegúrate de que los datos se envíen correctamente desde el cliente

        //borrado final
        $success = RegistroentradasSalidas::delEntradasSalidas($id);

        if ($success) {
            return response()->json(['message' => 'Registro eliminado exitosamente.'], 200);
        } else {
            return response()->json(['message' => 'No se encontró el registro o ocurrió un error.'], 404);
        }
    }


    //Prorateo
    public function prorrateoGastos()
    {
        // Usa el método personalizado del modelo para recuperar los datos
        $tablaG = ProrrateoGastos::getTablaProrrateo();

    
          // Retorna los datos en formato JSON
          return response()->json($tablaG);
    }

    public function update_bucket(Request $request)
    {
        $idRegistro = $request->input('ID_REGISTRO');
        $idBucket = $request->input('ID_BUCKET');

        $success = ProrrateoGastos::updateBucket( $idRegistro, $idBucket);

        $prueba = $success;

    }

    public function getCentroCostoData(Request $request)
    {

        // Obtener los parámetros del request
        $tipo = $request->input('tipo'); // 'ID_REGISTRO' o 'ID_PRORRATEO'
        $idValue = $request->input('idValue'); // El valor del ID

        if($tipo == "ID_REGISTRO"){
             // Obtener los datos desde el modelo
            $data = ProrrateoGastos::costos();

            // Enviar la respuesta en formato JSON
            return response()->json(['centroCostos' => $data]);
        }else if($tipo == "ID_PRORRATEO"){

            // $data = ProrrateoGastos::valProrr($idValue);

            $data = ProrrateoGastos::costos();

            $valorPro = ProrrateoGastos::valProrr($idValue);
            return response()->json([
                'centroCostos' => $data,
                'valoresCentroCostos' => $valorPro
            ]);
        }
       
    }

    public function getCentroCostoDataConFlu(Request $request)
    {

        // Obtener los parámetros del request
        $tipo = $request->input('tipo'); // 'ID_REGISTRO' o 'ID_PRORRATEO'
        $idValue = $request->input('idValue'); // El valor del ID

        if($tipo == "ID_REGISTRO"){
             // Obtener los datos desde el modelo
            $data = ConciliacionFlujos::costos();

            // Enviar la respuesta en formato JSON
            return response()->json(['centroCostos' => $data]);
        }else if($tipo == "ID_PRORRATEO"){

            // $data = ProrrateoGastos::valProrr($idValue);

            $data = ConciliacionFlujos::costos();

            $valorPro = ConciliacionFlujos::valProrr($idValue);
            return response()->json([
                'centroCostos' => $data,
                'valoresCentroCostos' => $valorPro
            ]);
        }
       
    }
    
    public function saveCentroCostos(Request $request){
        $request->validate([
            'idValue' => 'required|integer',
            'centroCostos' => 'required|array',
            'centroCostos.*.ID_CENTRO_COSTO' => 'nullable|integer',
            'centroCostos.*.VALUE' => 'nullable|numeric|min:0|max:1',
        ]);

        $idValue = $request->input('idValue');
        $centroCostos = $request->input('centroCostos');
        $status = $request->input('stats');

        // Calcular el total para validar que sume 1
        $totalValue = array_sum(array_column($centroCostos, 'VALUE'));

        if (round($totalValue, 2) != 1.00 && round($totalValue, 2) !== 0.00)  {
            return response()->json(['status' => 'error', 'message' => 'El prorrateo no cumple el 100%. Por favor, ajuste los valores.'], 400);
        }

        if ($status === 'update') {
            // Llamar al modelo para manejar la actualización
            $highestId = ProrrateoGastos::updateCostos($idValue, $centroCostos);
        } else {
            // Manejar la inserción normal
            $newIds = [];
            foreach ($centroCostos as $centro) {
                $newId = ProrrateoGastos::insertCostos($idValue, $centro['ID_CENTRO_COSTO'], $centro['VALUE']);
                $newIds[] = $newId;
            }
            // Obtener el ID más alto de los nuevos registros
            $highestId = !empty($newIds) ? max($newIds) : null;
        }

        return response()->json(['status' => 'success', 'newId' => $highestId], 200);
    }

    public function saveCentroCostosFlu(Request $request){
        $request->validate([
            'idValue' => 'required|integer',
            'centroCostos' => 'required|array',
            'centroCostos.*.ID_CENTRO_COSTO' => 'nullable|integer',
            'centroCostos.*.VALUE' => 'nullable|numeric|min:0|max:1',
        ]);

        $idValue = $request->input('idValue');
        $centroCostos = $request->input('centroCostos');
        $status = $request->input('stats');

        // Calcular el total para validar que sume 1
        $totalValue = array_sum(array_column($centroCostos, 'VALUE'));

        if (round($totalValue, 2) != 1.00 && round($totalValue, 2) !== 0.00)  {
            return response()->json(['status' => 'error', 'message' => 'El prorrateo no cumple el 100%. Por favor, ajuste los valores.'], 400);
        }

        if ($status === 'update') {
            // Llamar al modelo para manejar la actualización
            $highestId = ConciliacionFlujos::updateCostosFlu($idValue, $centroCostos);
        } else {
            // Manejar la inserción normal
            $newIds = [];
            foreach ($centroCostos as $centro) {
                $newId = ConciliacionFlujos::insertCostosFlu($idValue, $centro['ID_CENTRO_COSTO'], $centro['VALUE']);
                $newIds[] = $newId;
            }
            // Obtener el ID más alto de los nuevos registros
            $highestId = !empty($newIds) ? max($newIds) : null;
        }

        return response()->json(['status' => 'success', 'newId' => $highestId], 200);
    }


    public function tableConciliacionFlujos()
    {
        // Usa el método personalizado del modelo para recuperar los datos
        $tablaG = ConciliacionFlujos::getTablaConFlujos();

    
          // Retorna los datos en formato JSON
          return response()->json($tablaG);
    }

    public function update_eduFlu(Request $request)
    {
        // Usa el método personalizado del modelo para recuperar los datos
        $idValue = $request->input('ID_FLUJO');
        $catEdoFlu = $request->input('EDO_FLU_EFE');
        $ID_REGISTRO = $request->input('ID_REGISTRO');

        $updateEdoFlu = ConciliacionFlujos::updateCatflu( $idValue,$catEdoFlu,$ID_REGISTRO);

        return response()->json(['status' => 'success', 'cambios_actualizados' => $updateEdoFlu], 200);
    }

    public function update_bucketSel(Request $request)
    {
        // Usa el método personalizado del modelo para recuperar los datos
        $idValue = $request->input('ID_FLUJO');
        $bucket = $request->input('ID_BUCKET');
        $ID_REGISTRO = $request->input('ID_REGISTRO');

        $updateEdoFlu = ConciliacionFlujos::updateBuckFlu( $idValue,$bucket,$ID_REGISTRO);

        return response()->json(['status' => 'success', 'cambios_actualizados' => $updateEdoFlu], 200);
    }


    public function add_conFlu(Request $request)
    {
        // Usa el método personalizado del modelo para recuperar los datos
        $idValue = $request->input('ID_REGISTRO');
        $catEdoFlu = $request->input('EDO_FLU_EFE');

        $insertFlu = ConciliacionFlujos::insertFlu( $idValue,$catEdoFlu);

        return response()->json(['status' => 'success', 'newId' => $insertFlu], 200);
    }

    public function add_bucketS(Request $request)
    {
        // Usa el método personalizado del modelo para recuperar los datos
        $idValue = $request->input('ID_REGISTRO');
        $bucket = $request->input('ID_BUCKET');

        $insertFlu = ConciliacionFlujos::insertBk( $idValue,$bucket);

        return response()->json(['status' => 'success', 'newId' => $insertFlu], 200);
    }
}