<?php
namespace App\Http\Controllers;

use App\Pago;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;
use \Stripe\Stripe;

\Stripe\Stripe::setApiKey('sk_test_51PY93LRpEhuEXSEk6EBSwM0WCASlhV6EFQ4UWk5qTSP9NYdMv8nNtc9Bz5xDA9E6Y2pQcjghqkqU5xwFBSbdPRZZ00JVTIWUBP');

class PagoMembers extends Controller{
    public function storeM(Request $request)
    {
        //NUEVA FUNCION DE CODIGO
        //SI TIENE EL VALOR DE 292 TOMA EL VALOR EN DOLARES
        //SI NO, TOMA EL CODIGO NORMAL EN PESOS MEXICANOS
        //$currencyvalue = ($request ->mount=="299")?"usd":"mxn";
        $currencyvalue = ($request->mount == "310" || $request->mount == "1100" || $request->mount == "997" || $request->mount == "5999") ? "usd" : "mxn";
        //$this->ConfirmPlan
        
        try {
            
               
            $intent = \Stripe\PaymentIntent::create([
                'payment_method'         => $request->payment_method_id,
                'amount'                 => $request->mount * 100,
                
                //EN CURRENCY EL VALOR ORIGINAL ES 'mxn'
                //SE CAMBIA A $CURRENCYVALUE PARA QUE TOME EL VALOR DE LA VARIABLE
                
                'currency'               => $currencyvalue,
                'description'            => 'product: '.$request->product,
                'payment_method_options' => [
                    'card' => [
                        'installments' => [
                            'enabled' => true,
                        ],
                    ],
                ],
                'automatic_payment_methods' => [
                    'enabled' => true,
                    'allow_redirects' => 'never', // Evita métodos de pago que requieran redirección
                ],
                'metadata'=>[
                    'products'=> $request->product,
                    'email' => $request->email,
                    'name'=> $request->name,
                    'phone' => $request->phone,
                    'c.p.' => $request->cp,
                    //nuevo
                    // 'conversionDolar' => $usd_to_mxn_rate,
                    
                ],
            ]);
            echo json_encode([
                'intent_id'       => $intent->id,
                'available_plans' => $intent->payment_method_options->card->installments->available_plans,
            ]);
            
            
        } catch (\Stripe\Exception\CardException $e) {
            # "e" contains a message explaining why the request failed
            echo 'El mensaje de error de la tarjeta es:' . $e->getError()->message . '
';
            echo json_encode([
                'error_message' => $e->getError()->message,
            ]);
        } catch (\Stripe\Exception\InvalidRequestException $e) {
            // Invalid parameters were supplied to Stripe's API
            echo 'El mensaje de parámetros no válidos es:' . $e->getError()->message . '
';
            echo json_encode([
                'error_message' => $e->getError()->message,
            ]);
        }
    }

    //NEW
    public function ConfirmPlanM(Request $request)
    {
        if (isset($request->selected_plan)) {
            $confirm_data = ['payment_method_options' =>
                [
                    'card' => [
                        'installments' => [
                            'plan' => $request->selected_plan,
                        ],
                    ],
                ],
            ];
            $intent = \Stripe\PaymentIntent::retrieve(
                $request->payment_intent_id
            );

            $intent->confirm($params = $confirm_data);
            $fecha = date("Y-m-d");
            
            foreach ($request->selected_plan as $key => $value) {
                if ($key == 'count') {
                    /*Pago::create([
                        'nombre_cliente' => $request->name,
                        'correo'         => $request->email,
                        'telefono'       => $request->phone,
                        'fecha_pago'     => $fecha,
                        'monto'          => $request->mount,
                        'referido'       => (!empty(request('ref'))) ? request('ref') : null,
                        'plan'           => $value . ' meses',
                    ]);*/
                }
            }
            foreach ($intent  as $key => $value) {
                // $tipocard = $value->payment_method_details->card->brand;
                // $digitos  = $value->payment_method_details->card->last4;
                $cp       = $intent->metadata->{'c.p.'};
            }
            /*$response = Http::post('', [
                "nombre"     => $request->name,
                "correo"     => $request->email,
                "telefono"   => $request->phone,
                "fecha_pago" => $fecha,
                "monto"      => $request->mount,
                "referido"   => (!empty(request('ref'))) ? request('ref') : null,
                "plan"       => $request->selected_plan,
            ]);*/
            $responsedos = Http::post('https://hook.us1.make.com/fgpspyvv36rp2ajtwebvqomme8963u59', [
                "nombre"     => $request->name,
                "correo"     => $request->email,
                "telefono"   => $request->phone,
                "fecha_pago" => $fecha,
                "monto"      => $request->mount,
                "referido"   => (!empty(request('ref'))) ? request('ref') : null,
                "plan"       => $request->selected_plan,
                "type"       => 'form-msi',
                // "type-card"  => $tipocard,
                // "digitos"    => $digitos,
                "cp"         => $cp,
                "tags"       => $request->tags,
                "utm_medium" => $request->utm_medium,
                "utm_source" => $request->utm_source,
                "cf_uvid"    => $request->cf_uvid,
                "nombre_producto"=> $request->productname,
                "generacion"=> $request->generacion,
                
            ]);

            echo json_encode([
                'status' => $intent->status,
            ]);
        } else {
            if (isset($request->payment_intent_id)) {
                $intent = \Stripe\PaymentIntent::retrieve(
                    $request->payment_intent_id
                );
                try {
                    $intent->confirm();
                    if ($intent->status == 'succeeded') {
                        echo json_encode([
                            'status' => $intent->status,
                        ]);
                    $fecha = date("Y-m-d");
                    // foreach ($intent->charges->data as $key => $value) {
                        // $tipocard = $value->payment_method_details->card->brand;
                        // $digitos  = $value->payment_method_details->card->last4;
                        // $cp       = $value->billing_details->address->postal_code;
                        $cp       = $intent->metadata->{'c.p.'};
                    // }
                    /*Pago::create([
                        'nombre_cliente' => $request->name,
                        'correo'         => $request->email,
                        'telefono'       => $request->phone,
                        'fecha_pago'     => $fecha,
                        'monto'          => $request->mount,
                        'referido'       => (!empty(request('ref'))) ? request('ref') : null,
                        'plan'           => 'Pago inmediato',
                    ]);*/
                    //MODIFICAR DAVID
                    $responsedos = Http::post('https://hook.us1.make.com/fgpspyvv36rp2ajtwebvqomme8963u59', [
                        "nombre"     => $request->name,
                        "correo"     => $request->email,
                        "telefono"   => $request->phone,
                        "fecha_pago" => $fecha,
                        "monto"      => $request->mount,
                        "referido"   => (!empty(request('ref'))) ? request('ref') : null,
                        "plan"       => 'Pago inmediato',
                        "type"       => 'form-msi',
                        // "type-card"  => $tipocard,
                        // "digitos"    => $digitos,
                        "tags"       => $request->tags,
                        "utm_medium" => $request->utm_medium,
                        "utm_source" => $request->utm_source,
                        "cf_uvid"    => $request->cf_uvid,
                        "cp"         => $cp,
                        "nombre_producto"=> $request->productname,
                         "generacion"=> $request->generacion,
                    ]);
                    }else{
                        echo json_encode([
                            'success' => false, "data" => "pago no completado"
                        ]);
                    }
                } catch (\Stripe\Exception\CardException $e) {
                    return json_encode(['status' => $e->getError()->message]);
                }
            }
        }
    }
}