<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB; // Importar la clase DB

class CatModel extends Model
{
    
    public static function getTablaConFlujos()
    {
        return DB::select('SELECT 
                            ct.ID_CAT, 
                            ct.ID_N1,
                            ct.ID_N2,
                            ct.ID_N3,
                            ct.ID_N4,
                            ct.ID_N5,
                            ct.ID_N6,
                            ct.ID_N7,
                            ct.ID_TIPO_CUENTA,
                            ct.ID_NATURALEZA,
                            ct.ID_SAT,
                            ct.ID_REPORTE,
                            c1.NIVEL_1,
                            c2.NIVEL_2,
                            c3.NIVEL_3,
                            c4.NIVEL_4,
                            c5.NIVEL_5,
                            c6.NIVEL_6,
                            c7.NIVEL_7,
                            ctc.TIPO_CUENTA,
                            cn.NATURALEZA,
                            cs.CUENTA_SAT,
                            cr.REPORTE,
                            ct.CUENTA
                        FROM 
                            Finanzas.CAT_COMPLETO ct
                        LEFT JOIN CAT_NIVEL_1 c1 ON ct.ID_N1 = c1.ID_N1
                        LEFT JOIN CAT_NIVEL_2 c2 ON ct.ID_N2 = c2.ID_N2
                        LEFT JOIN CAT_NIVEL_3 c3 ON ct.ID_N3 = c3.ID_N3
                        LEFT JOIN CAT_NIVEL_4 c4 ON ct.ID_N4 = c4.ID_N4
                        LEFT JOIN CAT_NIVEL_5 c5 ON ct.ID_N5 = c5.ID_N5
                        LEFT JOIN CAT_NIVEL_6 c6 ON ct.ID_N6 = c6.ID_N6
                        LEFT JOIN CAT_NIVEL_7 c7 ON ct.ID_N7 = c7.ID_N7
                        LEFT JOIN CAT_TIPO_CUENTA ctc ON ct.ID_TIPO_CUENTA = ctc.ID_TIPO_CUENTA
                        LEFT JOIN CAT_NATURALEZA cn ON ct.ID_NATURALEZA = cn.ID_NATURALEZA
                        LEFT JOIN CAT_CUENTA_SAT cs ON ct.ID_SAT = cs.ID_SAT
                        LEFT JOIN CAT_REPORTE cr ON ct.ID_REPORTE = cr.ID_REPORTE
                        ORDER BY ct.ID_CAT DESC;
                        ');
                            }
    
    public static function getProveedores()
    {
        return DB::select('SELECT 
                            ID_PROVEEDOR, PROVEEDOR FROM CAT_PROVEEDORES ORDER BY ID_PROVEEDOR DESC ');
                            }


    public static function selectN1()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_1')
                        ->select('ID_N1','COD_N1', 'NIVEL_1')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }
    
    public static function selectN2()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_2')
                        ->select('ID_N2','COD_N2', 'NIVEL_2')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }

        public static function selectN3()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_3')
                        ->select('ID_N3','COD_N3', 'NIVEL_3')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }

        public static function selectN4()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_4')
                        ->select('ID_N4', 'COD_N4','NIVEL_4')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }

        public static function selectN5()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_5')
                        ->select('ID_N5','COD_N5', 'NIVEL_5')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }
        
        public static function selectN6()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_6')
                        ->select('ID_N6', 'COD_N6','NIVEL_6')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }
    
        public static function selectN7()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_7')
                        ->select('ID_N7','COD_N7', 'NIVEL_7')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }

        public static function tcuenta()
        {
            //traer datos
            $data = DB::table('CAT_TIPO_CUENTA')
                        ->select('ID_TIPO_CUENTA', 'TIPO_CUENTA')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }

        public static function naturaleza()
        {
            //traer datos
            $data = DB::table('CAT_NATURALEZA')
                        ->select('ID_NATURALEZA', 'NATURALEZA')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }
        public static function catSat()
        {
            //traer datos
            $data = DB::table('CAT_CUENTA_SAT')
                        ->select('ID_SAT', 'COD_SAT','CUENTA_SAT')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }    

        public static function cReports()
        {
            //traer datos
            $data = DB::table('CAT_REPORTE')
                        ->select('ID_REPORTE', 'REPORTE')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        } 

        public static function cat1()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_1')
                        ->select('ID_N1', 'COD_N1','NIVEL_1')
                        ->orderBy('ID_N1', 'desc')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }    
        
        public static function insertCatalogo($data)
        {

            $finalLevel = null;
            $valorNivel = null;

            for($i=7; $i>= 1; $i--){
                if(!empty($data["nivel$i"])){
                    $finalLevel = $data["nivel$i"];

                    $tabla = "CAT_NIVEL_$i";
                    $codigoColumna = "COD_N$i";
                    $nivelColumna = "NIVEL_$i";

                     $valorNivel = DB::table($tabla)
                            ->where("ID_N$i", $finalLevel)
                            ->select(DB::raw("CONCAT($codigoColumna, ' ', $nivelColumna) as valorConcatenado"))
                            ->value('valorConcatenado');
                    
                    break;
                }

            }
            // Inserta los datos en la tabla 'CAT_COMPLETO' y devuelve el ID del registro insertado
            return DB::table('Finanzas.CAT_COMPLETO')->insertGetId([
                'ID_N1' => $data['nivel1'],
                'ID_N2' => $data['nivel2'],
                'ID_N3' => $data['nivel3'],
                'ID_N4' => $data['nivel4'],
                'ID_N5' => $data['nivel5'],
                'ID_N6' => $data['nivel6'],
                'ID_N7' => $data['nivel7'],
                'ID_TIPO_CUENTA' => $data['tipoCuenta'],
                'ID_NATURALEZA' => $data['naturaleza'],
                'ID_SAT' => $data['cuentaSat'],
                'ID_REPORTE' => $data['reporte'],
                'CUENTA' => $valorNivel // Inserta el valor encontrado en CUENTA
            ]);
        }


        public static function insertProveedores($data)
        {
            try {
                DB::table('Finanzas.CAT_PROVEEDORES')->insert($data);  // Inserta múltiples registros
                return true;  // Inserción exitosa
            } catch (\Exception $e) {
                // Manejo del error
                return false; 
            }
        }
        
        public static function insertNivel1($data)
        {
            try {
                DB::table('Finanzas.CAT_NIVEL_1')->insert($data);  // Inserta múltiples registros
                return true;  // Inserción exitosa
            } catch (\Exception $e) {
                // Manejo del error
                return false; 
            }
        }

        public static function cat2()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_2')
                        ->select('ID_N2', 'COD_N2','NIVEL_2')
                        ->orderBy('ID_N2', 'desc')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }    

        public static function insertNivel2($data)
        {
            try {
                DB::table('Finanzas.CAT_NIVEL_2')->insert($data);  // Inserta múltiples registros
                return true;  // Inserción exitosa
            } catch (\Exception $e) {
                // Manejo del error
                return false; 
            }
        }

        public static function cat3()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_3')
                        ->select('ID_N3', 'COD_N3','NIVEL_3')
                        ->orderBy('ID_N3', 'desc')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }    

        public static function insertNivel3($data)
        {
            try {
                DB::table('Finanzas.CAT_NIVEL_3')->insert($data);  // Inserta múltiples registros
                return true;  // Inserción exitosa
            } catch (\Exception $e) {
                // Manejo del error
                return false; 
            }
        }

        public static function cat4()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_4')
                        ->select('ID_N4', 'COD_N4','NIVEL_4')
                        ->orderBy('ID_N4', 'desc')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }    

        public static function insertNivel4($data)
        {
            try {
                DB::table('Finanzas.CAT_NIVEL_4')->insert($data);  // Inserta múltiples registros
                return true;  // Inserción exitosa
            } catch (\Exception $e) {
                // Manejo del error
                return false; 
            }
        }

        public static function cat5()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_5')
                        ->select('ID_N5', 'COD_N5','NIVEL_5')
                        ->orderBy('ID_N5', 'desc')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }    

        public static function insertNivel5($data)
        {
            try {
                DB::table('Finanzas.CAT_NIVEL_5')->insert($data);  // Inserta múltiples registros
                return true;  // Inserción exitosa
            } catch (\Exception $e) {
                // Manejo del error
                return false; 
            }
        }

        public static function cat6()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_6')
                        ->select('ID_N6', 'COD_N6','NIVEL_6')
                        ->orderBy('ID_N6', 'desc')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }    

        public static function insertNivel6($data)
        {
            try {
                DB::table('Finanzas.CAT_NIVEL_6')->insert($data);  // Inserta múltiples registros
                return true;  // Inserción exitosa
            } catch (\Exception $e) {
                // Manejo del error
                return false; 
            }
        }

        public static function cat7()
        {
            //traer datos
            $data = DB::table('CAT_NIVEL_7')
                        ->select('ID_N7', 'COD_N7','NIVEL_7')
                        ->orderBy('ID_N7', 'desc')
                        ->get();
                        
            // devolver los datos
            return $data->toArray(); 
        }    

        public static function insertNivel7($data)
        {
            try {
                DB::table('Finanzas.CAT_NIVEL_7')->insert($data);  // Inserta múltiples registros
                return true;  // Inserción exitosa
            } catch (\Exception $e) {
                // Manejo del error
                return false; 
            }
        }

        public static function updateTab1($data)
        {
            
            $finalLevel = null;
            $valorNivel = null;

            for($i=7; $i>= 1; $i--){
                if(!empty($data["nivel$i"])){
                    $finalLevel = $data["nivel$i"];

                    $tabla = "CAT_NIVEL_$i";
                    $codigoColumna = "COD_N$i";
                    $nivelColumna = "NIVEL_$i";

                     $valorNivel = DB::table($tabla)
                            ->where("ID_N$i", $finalLevel)
                            ->select(DB::raw("CONCAT($codigoColumna, ' ', $nivelColumna) as valorConcatenado"))
                            ->value('valorConcatenado');
                    
                    break;
                }

            }
            
              // Asumiendo que 'ID_CAT' es el identificador único para la fila que deseas actualizar
            $updated = DB::table('CAT_COMPLETO') // Especificamos la tabla
            ->where('ID_CAT', $data['ID_CAT']) // Condición para encontrar el registro con ese ID
            ->update([
                'ID_N1' => $data['nivel1'],
                'ID_N2' => $data['nivel2'],
                'ID_N3' => $data['nivel3'],
                'ID_N4' => $data['nivel4'],
                'ID_N5' => $data['nivel5'],
                'ID_N6' => $data['nivel6'],
                'ID_N7' => $data['nivel7'],
                'ID_TIPO_CUENTA' => $data['tipoCuenta'],
                'ID_NATURALEZA' => $data['naturaleza'],
                'ID_SAT' => $data['cuentaSat'],
                'ID_REPORTE' => $data['reporte'],
                'CUENTA' => $valorNivel
            ]);

        // Retorna true si se actualizó al menos una fila
        return $updated > 0;
        }

        public static function updateProv($idProveedor, $proveedor){
           
            $updated = DB::table('CAT_PROVEEDORES')
            ->where('ID_PROVEEDOR', $idProveedor)
            ->update(['PROVEEDOR' => $proveedor]);

            return $updated > 0;
        }

        public static function updateCn1($ID_N1, $COD_N1,$NIVEL_1){
           
            $updated = DB::table('CAT_NIVEL_1')
            ->where('ID_N1', $ID_N1)
            ->update(['COD_N1' => $COD_N1, 'NIVEL_1' =>$NIVEL_1] );

            return $updated > 0;
        }

        public static function updateCn2($ID_N2, $COD_N2,$NIVEL_2){
           
            $updated = DB::table('CAT_NIVEL_2')
            ->where('ID_N2', $ID_N2)
            ->update(['COD_N2' => $COD_N2, 'NIVEL_2' =>$NIVEL_2] );

            return $updated > 0;
        }
        
        public static function updateCn3($ID_N3, $COD_N3,$NIVEL_3){
           
            $updated = DB::table('CAT_NIVEL_3')
            ->where('ID_N3', $ID_N3)
            ->update(['COD_N3' => $COD_N3, 'NIVEL_3' =>$NIVEL_3] );

            return $updated > 0;
        }
        
        public static function updateCn4($ID_N4, $COD_N4,$NIVEL_4){
           
            $updated = DB::table('CAT_NIVEL_4')
            ->where('ID_N4', $ID_N4)
            ->update(['COD_N4' => $COD_N4, 'NIVEL_4' =>$NIVEL_4] );

            return $updated > 0;
        }

        public static function updateCn5($ID_N5, $COD_N5,$NIVEL_5){
           
            $updated = DB::table('CAT_NIVEL_5')
            ->where('ID_N5', $ID_N5)
            ->update(['COD_N5' => $COD_N5, 'NIVEL_5' =>$NIVEL_5] );

            return $updated > 0;
        }

        public static function updateCn6($ID_N6, $COD_N6,$NIVEL_6){
           
            $updated = DB::table('CAT_NIVEL_6')
            ->where('ID_N6', $ID_N6)
            ->update(['COD_N6' => $COD_N6, 'NIVEL_6' =>$NIVEL_6] );

            return $updated > 0;
        }

        public static function updateCn7($ID_N7, $COD_N7,$NIVEL_7){
           
            $updated = DB::table('CAT_NIVEL_7')
            ->where('ID_N7', $ID_N7)
            ->update(['COD_N7' => $COD_N7, 'NIVEL_7' =>$NIVEL_7] );

            return $updated > 0;
        }
}
