<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Finanzas</title>
     <!-- Bootstrap CSS -->
     <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
    <!-- DataTables CSS -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.12.1/css/jquery.dataTables.min.css">
    <!-- Custom CSS -->
    <link rel="stylesheet" href="{{ route('finanzasTable.css') }}">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css">
    <!-- FullCalendar CSS -->
    <link href="https://cdn.jsdelivr.net/npm/fullcalendar@5.10.1/main.min.css" rel="stylesheet">
    <!-- jQuery UI CSS -->
    <link rel="stylesheet" href="https://code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
    <!-- Select2 CSS -->
    <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>
<body>

    <div class="container mt-5">
        <div id="calendar"></div>
    </div>
    <!-- Navbar -->
    <nav class="navbar navbar-expand-lg navbar-dark">
        <span class="navbar-brand mb-0 h1">Finanzas</span>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav ml-auto">
               <li class="nav-item">
                    <a class="nav-link" href="{{ url('/catalogos') }}">Catálagos</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url('/finanzas') }}">Registro Entradas y Salidas</a>
                </li>
                <li class="nav-item">
                    <label class="nav-link" style="color:white;">Centro de Gastos</label>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url('/conciliacion_flujo') }}">Conciliación de Flujo</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" id="sidebarToggle">☰</a>
                </li>
            </ul>
        </div>
    </nav>

    <!-- Sidebar -->
    <div class="sidebar" id="sidebar">
        <a href="https://panel.fivetwofive.tech/fwf/public/finanzas">Nublogin</a>
        <!-- <a href="#services">Hoog</a> -->
        <!-- <a href="#clients">Nublogin</a> -->
        <!-- <a href="#contact">Contacto</a> -->
    </div>

    <!-- Content -->
    <div class="content" id="content">
        <h2>Centro de Gastos &nbsp;<i class="fa fa-usd" aria-hidden="true"></i></h2>
        <div id='divAddSave' class="d-flex justify-content-end mb-3">
    </div>
    <label>
        <input type="checkbox" id="bucketFilter" />
        Gastos sin prorreatar.
    </label>
    <!-- <label>
        <input type="checkbox" id="ccFilter" />
        Mostrar Control de Costos vacíos.
    </label> -->

        <div class="table-responsive">
            <table id="flujoTable" class="table table-hover display">
                <thead>
                    <tr>
                        <th>ID_COSTO</th>
                        <th>ID_REGISTRO</th>
                        <th>FECHA</th>
                        <th>CUENTA</th>
                        <th>CARGO</th>
                        <th>ABONO</th>
                        <th>CC</th>
                        <!-- <th>BUCKET</th> -->
                        <th style="display:none"></th>
                        <th style="display:none"></th>
                        <th style="display:none"></th>
                        <th style="display:none"></th>
                        <th style="display:none"></th>
                    </tr>
                </thead>
                <tbody>
                    <!-- Aquí se llenará dinámicamente con jQuery -->
                </tbody>
            </table>
        </div>
    </div>

    <div class="overlay" id="overlay">
        <span class="loader"></span>
    </div>
    <!-- Control de gastos Modal -->
   <!-- Modal -->
    <div id="modalcc" class="modal fade" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">CONTROLES DE GASTOS</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form id="delete-options-form">
                        <div class="form-group" id="centroCostoContainer">
                            <!-- Las filas se agregarán aquí dinámicamente -->
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
                    <button type="button" id="saveCentroCosto" class="btn btn-primary">Guardar</button>
                </div>
                <div class="overlay" id="modalOverlay">
                    <span class="loader"></span>
                </div>
            </div>
        </div>
    </div>





    <footer>
        <!-- jQuery and Bootstrap JS -->
        <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
        <!-- DataTables JS -->
        <script src="https://cdn.datatables.net/1.12.1/js/jquery.dataTables.min.js"></script>
        <!-- FullCalendar JS -->
        <script src="https://cdn.jsdelivr.net/npm/fullcalendar@5.10.1/main.min.js"></script>
        <!-- jQuery UI JS -->
        <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.min.js"></script>
        <!-- Select2 JS -->
        <script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script>
        <!-- Your custom JS -->
        <script src="{{ route('selectsData.js') }}"></script>
        <script src="{{ route('prorrateoFinanzas.js') }}"></script>
    </footer>

</body>
</html>
