<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PagoController;
use App\Http\Controllers\FinanzasDat;
use App\Http\Controllers\PagoMembers;
use App\Http\Controllers\PagoLiberador;
use App\Http\Controllers\Generaficha;
use App\Http\Controllers\Generaficha_Membresia;
use App\Http\Controllers\Generaficha_Liberador;
use App\Http\Controllers\Catalogos;

// Route::get('/', function () {
//     return view('welcome');
// });

// Route::post('/Plans', 'PagoController@store')->name('plans'); 
Route::post('/Plans', [PagoController::class, 'store'])->name('plans'); //update

Route::post('/ConfirmPlan', [PagoController::class, 'ConfirmPlan'])->name('confirm'); //update
// Route::post('/ConfirmPlan', 'PagoController@ConfirmPlan')->name('confirm'); 

///////////Membresias//////////
Route::get('/memberships', function () {
    return view('memberships');
});

Route::post('/PlansM', [PagoMembers::class, 'storeM'])->name('plansM');
Route::post('/ConfirmPlanM', [PagoMembers::class, 'ConfirmPlanM'])->name('confirmM');
//
//Liberador Corporativo
Route::get('/liberadorCorp', function () {
    return view('liberadorCorp');
});
Route::post('/PlansCo', [PagoLiberador::class, 'storeL'])->name('PlansCo');
Route::post('/ConfirmPlanCo', [PagoLiberador::class, 'ConfirmPlanCo'])->name('confirmCo');

Route::get('/ir-a-google', [PagoController::class, 'redirectToGoogle'])->name('ir_a_google');

Route::get('/css/my.style.css', function () {
    return response()->file(public_path('css/my.style.css'));
})->name('style.css');

Route::get('/js/alertify.js', function () {
    return response()->file(public_path('alertifyjs/alertify.js'));
})->name('alertify.js');

Route::get('/css/alertify.css', function () {
    return response()->file(public_path('alertifyjs/css/alertify.css'));
})->name('alertify.css');

Route::get('logo.png', function () {
    return response()->file(public_path('logo.png'));
})->name('logo.png');

Route::post('/generarFicha', [Generaficha::class, 'generarFicha']);

Route::post('/generarFichaMemb', [Generaficha_Membresia::class, 'generarFichaM']);

Route::post('/generarFichaLib', [Generaficha_Liberador::class, 'generarFichaL']);

//Finanzas
Route::get('/', function () {
    return view('finanzas');
});

Route::get('/finanzas', function () {
    return redirect('/');
});

Route::get('/css/finanzasTable.css', function () {
    return response()->file(public_path('css/finanzasTable.css'));
})->name('finanzasTable.css');


Route::get('/js/registroEntradasSalidas.js', function () {
    return response()->file(public_path('js/registroEntradasSalidas.js'));
})->name('registroEntradasSalidas.js');

Route::get('/js/selectsData.js', function () {
    return response()->file(public_path('js/selectsData.js'));
})->name('selectsData.js');


Route::get('/tableFinanzas', [FinanzasDat::class, 'tableEntradasSalidas']);

Route::get('/select2/{catalogo}', [FinanzasDat::class, 'select2']);

Route::post('/addEntradasSalidas', [FinanzasDat::class, 'addEntradasSalidas']);

Route::post('/updateEntradasSalidas', [FinanzasDat::class, 'updateEntradasSalidas']);

Route::post('/delEntradasSalidas', [FinanzasDat::class, 'delEntradasSalidas']);

Route::get('/prorrateo', function () {
    return view('prorrateo');
});
Route::get('/conciliacion_flujo', function () {
    return view('conciliacionFlujo');
});

Route::get('/js/prorrateoFinanzas.js', function () {
    return response()->file(public_path('js/prorrateoFinanzas.js'));
})->name('prorrateoFinanzas.js');

Route::get('/tableProrrateo', [FinanzasDat::class, 'prorrateoGastos']);

Route::post('/act_bucket', [FinanzasDat::class, 'update_bucket']);

Route::get('/getCentroCostoData', [FinanzasDat::class, 'getCentroCostoData']);

Route::post('/saveCentroCostos', [FinanzasDat::class, 'saveCentroCostos']);

// conciliacion flujo
Route::get('/js/conciliacionFlujo.js', function () {
    return response()->file(public_path('js/conciliacionFlujo.js'));
})->name('conciliacionFlujo.js');

Route::get('/tableConciliacionFlujos', [FinanzasDat::class, 'tableConciliacionFlujos']);

Route::post('/act_eduFlu', [FinanzasDat::class, 'update_eduFlu']);

Route::post('/act_bucketS', [FinanzasDat::class, 'update_bucketSel']);

Route::post('/add_conFlu', [FinanzasDat::class, 'add_conFlu']);

Route::post('/add_bucketS', [FinanzasDat::class, 'add_bucketS']);

Route::get('/catalogos', function () {
    return view('catalogos');
});


Route::get('/js/tablaCats.js', function () {
    return response()->file(public_path('js/tablaCats.js'));
})->name('tablaCats.js');

Route::get('/catPrincipal', [Catalogos::class, 'catPrincipal']);

Route::get('/js/selectCats.js', function () {
    return response()->file(public_path('js/selectCats.js'));
})->name('selectCats.js');

Route::post('/insertCatCompleto', [Catalogos::class, 'insertCats']);

Route::get('/proveedores', [Catalogos::class, 'proveedores']);

Route::post('/insertProveedor', [Catalogos::class, 'insertProveedor']);

Route::get('/cat1', [Catalogos::class, 'cat1']);

Route::post('/insertNivel1', [Catalogos::class, 'insertNivel1']);

Route::get('/cat2', [Catalogos::class, 'cat2']);

Route::post('/insertNivel2', [Catalogos::class, 'insertNivel2']);

Route::get('/cat3', [Catalogos::class, 'cat3']);

Route::post('/insertNivel3', [Catalogos::class, 'insertNivel3']);

Route::get('/cat4', [Catalogos::class, 'cat4']);

Route::post('/insertNivel4', [Catalogos::class, 'insertNivel4']);

Route::get('/cat5', [Catalogos::class, 'cat5']);

Route::post('/insertNivel5', [Catalogos::class, 'insertNivel5']);

Route::get('/cat6', [Catalogos::class, 'cat6']);

Route::post('/insertNivel6', [Catalogos::class, 'insertNivel6']);

Route::get('/cat7', [Catalogos::class, 'cat7']);

Route::post('/insertNivel7', [Catalogos::class, 'insertNivel7']);

Route::post('/updateCat1', [Catalogos::class, 'updateCat1']);

Route::post('/updateCn1', [Catalogos::class, 'updateCn1']);

Route::post('/updateCn2', [Catalogos::class, 'updateCn2']);

Route::post('/updateCn3', [Catalogos::class, 'updateCn3']);

Route::post('/updateCn4', [Catalogos::class, 'updateCn4']);

Route::post('/updateCn5', [Catalogos::class, 'updateCn5']);

Route::post('/updateCn6', [Catalogos::class, 'updateCn6']);

Route::post('/updateCn7', [Catalogos::class, 'updateCn7']);

Route::get('/getCentroCostoDataConFlu', [FinanzasDat::class, 'getCentroCostoDataConFlu']);

Route::post('/saveCentroCostosFlu', [FinanzasDat::class, 'saveCentroCostosFlu']);

Route::post('/updateProveedoresTab', [Catalogos::class, 'updateProveedoresTab']);