<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Finanzas</title>
     <!-- Bootstrap CSS -->
     <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
    <!-- DataTables CSS -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.12.1/css/jquery.dataTables.min.css">
    <!-- Custom CSS -->
    <link rel="stylesheet" href="<?php echo e(route('finanzasTable.css')); ?>">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css">
    <!-- FullCalendar CSS -->
    <link href="https://cdn.jsdelivr.net/npm/fullcalendar@5.10.1/main.min.css" rel="stylesheet">
    <!-- jQuery UI CSS -->
    <link rel="stylesheet" href="https://code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
    <!-- Select2 CSS -->
    <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="<?php echo e(route('selectsData.js')); ?>"></script>
    <script src="<?php echo e(route('selectCats.js')); ?>"></script>
</head>
<body>

    <div class="container mt-5">
        <div id="calendar"></div>
    </div>
    <!-- Navbar -->
    <nav class="navbar navbar-expand-lg navbar-dark">
        <span class="navbar-brand mb-0 h1">Finanzas</span>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <label class="nav-link" style="color:white;">Catálogos</label>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="<?php echo e(url('/finanzas')); ?>">Registro Entradas y Salidas</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="<?php echo e(url('/prorrateo')); ?>">Centro de Gastos</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="<?php echo e(url('/conciliacion_flujo')); ?>">Conciliación de Flujo</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" id="sidebarToggle">☰</a>
                </li>
            </ul>
        </div>
    </nav>

    <!-- Sidebar -->
    <div class="sidebar" id="sidebar">
        <a href="https://panel.fivetwofive.tech/fwf/public/finanzas">Nublogin</a>
        <!-- <a href="#services">Hoog</a> -->
        <!-- <a href="#clients">Nublogin</a> -->
        <!-- <a href="#contact">Contacto</a> -->
    </div>

    <!-- Content -->
    <div class="content" id="content">
        <h2>Catálogos &nbsp;<i class="fa fa-files-o" aria-hidden="true"></i></h2>
        <div id='divAddSave' class="d-flex justify-content-end mb-3">
            <!-- uso del js  -->
        </div>
        
        <!-- Contenedor principal de catálogos y tabla -->
        <div class="catalog-table-container">
            <!-- Contenedor de los catálogos -->
            <div class="catalog-container">
                <a href="#" data-catalog="1" class="catalog-item">Catálogo Principal</a>
                <a href="#" data-catalog="2" class="catalog-item">Catálogo Proveedores</a>
                <a href="#" data-catalog="3" class="catalog-item">Catálogo 1</a>
                <a href="#" data-catalog="4" class="catalog-item">Catálogo 2</a>
                <a href="#" data-catalog="5" class="catalog-item">Catálogo 3</a>
                <a href="#" data-catalog="6" class="catalog-item">Catálogo 4</a>
                <a href="#" data-catalog="7" class="catalog-item">Catálogo 5</a>
                <a href="#" data-catalog="8" class="catalog-item">Catálogo 6</a>
                <a href="#" data-catalog="9" class="catalog-item">Catálogo 7</a>
            </div>

            <!-- Contenedor de la tabla mini -->
            <div id="miniTableContainer">
                <!-- Aquí se cargarán las tablas dinámicamente -->
            </div>
        </div>
    </div>

    <div class="overlay" id="overlay">
        <span class="loader"></span>
    </div>

    <!-- Modal -->
    <div id="myModal" class="modal fade" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Selecciona tus opciones</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <!-- Create 12 select inputs organized in 4 columns by 3 rows -->
                    <form id="modalForm">
                        <div class="row">
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 1</label>
                                    <select id="select1" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 2</label>
                                    <select id="select2" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 3</label>
                                    <select id="select3" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 4</label>
                                    <select id="select4" class="form-control">
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 5</label>
                                    <select id="select5" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 6</label>
                                    <select id="select6" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 7</label>
                                    <select id="select7" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Tipo de Cuenta</label>
                                    <select id="selectTpCuenta" class="form-control long-select">
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Naturaleza</label>
                                    <select id="selectNat" class="form-control long-select">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Cuenta Sat</label>
                                    <select id="selectCsat" class="form-control long-select">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Reporte</label>
                                    <select id="selectReport" class="form-control long-select">
                                    </select>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
                    <button id='insertFi' type="button" class="btn btn-primary">Insertar Fila</button>
                </div>
            </div>
        </div>
    </div>

    <!-- Modal update -->

    <div id="myModalUp" class="modal fade" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Selecciona tus opciones</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <!-- Create 12 select inputs organized in 4 columns by 3 rows -->
                    <form id="modalForm">
                        <div class="row">
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 1</label>
                                    <select id="select1Up" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 2</label>
                                    <select id="select2Up" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 3</label>
                                    <select id="select3Up" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 4</label>
                                    <select id="select4Up" class="form-control">
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 5</label>
                                    <select id="select5Up" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 6</label>
                                    <select id="select6Up" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Nivel 7</label>
                                    <select id="select7Up" class="form-control">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Tipo de Cuenta</label>
                                    <select id="selectTpCuentaUp" class="form-control long-select">
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Naturaleza</label>
                                    <select id="selectNatUp" class="form-control long-select">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Cuenta Sat</label>
                                    <select id="selectCsatUp" class="form-control long-select">
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label >Reporte</label>
                                    <select id="selectReportUp" class="form-control long-select">
                                    </select>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
                    <button id='actualizarFi' type="button" class="btn btn-primary">Actualizar Fila</button>
                </div>
            </div>
        </div>
    </div>
    <footer>
        <!-- jQuery and Bootstrap JS -->
        <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
        <!-- DataTables JS -->
        <script src="https://cdn.datatables.net/1.12.1/js/jquery.dataTables.min.js"></script>
        <!-- FullCalendar JS -->
        <script src="https://cdn.jsdelivr.net/npm/fullcalendar@5.10.1/main.min.js"></script>
        <!-- jQuery UI JS -->
        <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.min.js"></script>
        <!-- Select2 JS -->
        <script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script>
       
        <script src="<?php echo e(route('tablaCats.js')); ?>"></script>

     

    </footer>

</body>
</html>
<?php /**PATH /home/panelfivetwofive/public_html/yaaxlum/resources/views/catalogos.blade.php ENDPATH**/ ?>